package internal

import (
	"context"
	"testing"

	"github.com/open-io/oio-exporter/common"
	"github.com/open-io/oio-exporter/testutils"
)

func TestInternalModule(t *testing.T) {
	t.Parallel()

	m := common.MakeMetricData()
	d := MakeDaemon()

	if err := d.Init(nil, nil); err != nil {
		t.Fatalf("Init error: %s", err)
	}

	if err := d.Collect(m); err != nil {
		t.Fatalf("Collect error: %s", err)
	}

	if err := d.Close(context.TODO()); err != nil {
		t.Fatalf("Close error: %s", err)
	}

	testutils.NewMetricDataTest().
		HasMetrics("self_mem_alloc_current", "self_mem_alloc_max", "self_num_goroutines").
		NoExtraMetrics().
		Check(t, m)
}
